Subject: find-named-dired followed by Query and Replace leaves emacs in a bad state

From: Chris Corbyn <[email-masked]>
Date: Thu, 1 Dec 2011 08:08:40 +1100

Hi All,

See http://stackoverflow.com/questions/8321589/emacs-find-and-replace-regex-in-multiple-files-find-name-dired-q-doesnt-sa/8329696#8329696 for the original question.  I've been told to officially report the bug.

Basically I'm trying to find & replace across all files in my project; which I'm doing by starting find-name-dired, then selecting all the files in my project, hitting "Q" for Query & Replace, and following the interactive process.

It is doing the search and replace in exactly the way I'd expect, but she  I try to save the 27 buffers it leaves open (using save-some-buffers) it says there are no changes to be saved.  Trying to save a single buffer does the same thing, yet I can see the changes clear as day.  Editing the buffer and saving it again does work, but this is not practical over 27 of them; obviously there's a bug here with the find & replace not marking the buffers as modified.

I also tried using IBuffer to save all the buffers, which reported to have saved them, but actually hadn't written anything to disk.  I assume that IBuffer's reporting of what it saved is actually just telling me how many buffers were selected when I asked it to save the, but is not checking to make sure they really did save.

Can somebody please confirm that this is a bug and/or provide a suitable workaround? :)  I'd just do this on the command line if I didn't need to do it interactively, due to some ambiguities.

Cheers,

Chris